/**
 * Redistribution and use of this software and associated
 * documentation ("Software"), with or without modification, are
 * permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright statements
 *    and notices.  Redistributions must also contain a copy of this
 *    document.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of one of the parties involved in the TRANSORG project. For
 * 	  written permission, please contact diasz@ida.liu.se.
 *
 * 4. Products derived from this Software may not be called "TRANSORG"
 *    nor may "TRANSORG" appear in their names without prior written
 *    permission.
 *
 * 5. Due credit should be given to the TRANSORG Project
 *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
 *
 * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.
 *
 * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
 *
 * $Id: JavaObjFact_name.java,v 1.0 2003/08/04 08:07:19 diasz Exp $
 *
 * Date         Author  Changes
 */

/* The local factory implementation for the application object creation*/

/* The application object class is SimpleImpl with interface Simple*/

package a.package.name;
import org.omg.FT.*; /* Package name where the FT_CORBA infrastructure classes reside*/
import package.name.of.application.object.X;
import package.name.of.application.object.Y;
//.............................

class ExcThread extends Thread{

    org.omg.PortableServer.POA poa;
    org.omg.CORBA.ORB orb;

    public ExcThread(org.omg.PortableServer.POA poa,org.omg.CORBA.ORB orb){
	this.orb=orb;
	this.poa=poa;
    }

    public void run(){
	try{
	    poa.the_POAManager().activate();
	}catch(Exception e){}
	orb.run();
    }
}

/** Sample Java Object Factory class - HAS TO BE WRITTEN BY THE APPLICATION WRITER to incorporate initialization operations
 * for the specific application objects it has to create
 * It is used to create the application object replica running on its host, but in a different java virtual machine than the
 * factory contacted by the Replication Manager and the other application object replicas members of other groups on the same host
 * @author <a href="mailto:diasz@ida.liu.se"> Diana Szentivanyi </a>
 * @version $Revision: 1.0 $ $Date:2003/06/23$
 */

/** The main method of this java class is run by using an "exec" command with a set of command line arguments run from the application object factory when this is requested by the
* Replication Manager to create a new application object group replica; the command line arguments describe the replication style, whether this replica is activated
* or only created, if, in case of active replication, this replica is the first one (in such a case a gateway object is also created), etc.
*/

public class SampleJavaObjectFactory {

    static String location,ftDom;

    public static void main(String[] args){
       	boolean found_oi=false,activate=false,active=false,stateless=false,warm_passive=false,join=false,is_backup=false,debug=false;
	byte[] oid=new byte[0];
	int next_i,type,i,sz,life_l=-1;
	org.omg.PortableServer.POA new_poa,r_poa=null,gw_poa=null;
	org.omg.CORBA.ORB o_orb,gw_orb=null;
	String client_id,real_client_id,type_id;
	java.io.RandomAccessFile trace_file=null,trace_file_gsu=null,trace_file_gw=null;
	org.omg.CORBA.Object gateway=null,toReturn;
	java.lang.Object the_inst=null;
	ft.application.SimpleImpl inst_s;
	long oid_l=-1;

	if(args[0].charAt(0)=='1'){
	    create_gateway(args);
	    return;
	}




	location=args[1];
	ftDom=args[2];
	type_id=args[3];
	if(args[4].charAt(0)=='1')
	    debug=true;
	next_i=6;
	switch(args[5].charAt(0)){
	case '1':
	    found_oi=true;
	    oid=new byte[8];
	    for(i=0;i<8;i++)
		oid[i]=Byte.parseByte(args[i+6]);
	    next_i=i+6;
	    oid_l=org.omg.FT.Utils.makeByteId(oid);
	    break;
	case '2':
	    found_oi=true;
	    sz=Integer.parseInt(args[6]);
	    oid=new byte[sz];
	    for(i=0;i<sz;i++)
		oid[i]=Byte.parseByte(args[i+7]);
	    next_i=i+6;
	    oid_l=org.omg.FT.Utils.makeByteId(oid);
	    break;
	case '0':
	    next_i=6;
	    break;
	}
	if(args[next_i++].charAt(0)=='1') activate=true;
	if(args[next_i++].charAt(0)=='1') active=true;
	if(args[next_i++].charAt(0)=='1') join=true;
	if(args[next_i++].charAt(0)=='1') stateless=true;
	if(args[next_i++].charAt(0)=='1') warm_passive=true;
	if(args[next_i++].charAt(0)=='1') is_backup=true;

	if(args[next_i++].length()==1)
	    life_l=Integer.parseInt(args[next_i]);
	else
	    life_l=1000;

	if(found_oi)
	    client_id=Long.toString(oid_l);
	else
	    client_id="";

	real_client_id=client_id+"***"+ftDom;
	if(active) type=org.omg.FT.ACTIVE.value;
	else
	    if(stateless)
		type=org.omg.FT.STATELESS.value;
	    else
		if(warm_passive)
		    type=org.omg.FT.WARM_PASSIVE.value;
		else
		    type=org.omg.FT.COLD_PASSIVE.value;

	String class_name=org.omg.FT.Utils.get_class_name(type_id);

	/** if tracing of timing information is needed, the trace file has to be defined in this method and set in the ORB as a feature
	 * The method get_orb receives the trace_file values as parameters; the method can be changed if there is no need for tracing, to not
	 * expect the two parameters
	*/

	o_orb=get_orb(type,real_client_id,trace_file,trace_file_gsu);
	try{
	    o_orb.resolve_initial_references("NameService");
	}catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));}
	if(is_backup) {
	    ((org.openorb.CORBA.ORB)o_orb).setFeature("backup",new java.lang.Object());
	}

	 /** Here the servant object instance has to be created, depending on the type_id given
	  * An example is given below.
	  * NOTE: the class a.b.ImplC does not exist!!
	  * The information about the constructor to be called and its arguments, can be transmitted by the application object factory
	  * as command line arguments, to be read from a file, or be hardcoded!!!
	  */

    a.b.ImplC inst_s;

	if(type_id.equals("IDL:a/b/InterfaceNameC:1.0")){
	    inst_s=new a.b.ImpcC(12,true,"aaa");
	    the_inst=(java.lang.Object)inst_s;
	}

	/* end servant object creation  - used application dependent data*/

	if(active&&join)
	    ((org.openorb.CORBA.ORB)o_orb).setFeature("wait_set_state",new java.lang.Object());

	new_poa=get_obj_poa(o_orb,client_id);

	if(found_oi)
	    ((org.openorb.CORBA.ORB)o_orb).setFeature("theOID",oid);
	((org.openorb.CORBA.ORB)o_orb).setFeature("theServant",the_inst);

	if(found_oi&&(activate||active||warm_passive)){
	    if(new_poa!=null&&the_inst!=null)
		try{
		    new_poa.activate_object_with_id(oid,(org.omg.PortableServer.Servant)the_inst);
		}catch(java.lang.Exception e){}
	}


	org.omg.CORBA.Object ref_id_to_ret=null;

	try{
	    ref_id_to_ret=new_poa.create_reference_with_id(oid,type_id);
	}catch(Exception e){e.printStackTrace(new java.io.PrintStream(System.out));return;}

	if(active)
	    ((org.openorb.CORBA.ORB)o_orb).setFeature("its_replica",Utils.get_ior(ref_id_to_ret));

	new ExcThread(new_poa,o_orb).start();
	System.out.println("%%REF IS%%"+o_orb.object_to_string(ref_id_to_ret));
    }


    private static org.omg.CORBA.ORB get_orb(int type,String client_id,java.io.RandomAccessFile trace_file,java.io.RandomAccessFile trace_file_gsu){

	org.omg.CORBA.ORB o;
	String[] one_arg=new String[1];
	java.util.Properties prop=new java.util.Properties();
	int i;
	org.omg.CORBA.Any a;
	LoggingRecoveryController l_g_r_c;
	prop.put("org.omg.CORBA.ORBClass","org.openorb.CORBA.ORB");
	prop.put("org.omg.CORBA.ORBSingletonClass","org.openorb.CORBA.ORBSingleton");

	/** Depending on the replication style, different interceptors will be created and attached to the ORB where the application object is running.
	* The type of interceptor depends on the Initializer that is started and creates the interceptors, and this depends on the profile name chosen;
	* profile names and their corresponding initializers are described in the OpenORB.xml file. NOTE that profile names as well as their corresponding
	* initializer classes can be changed, so that different interceptors are created
	*/

	switch(type){
	case org.omg.FT.COLD_PASSIVE.value:one_arg[0]="-ORBProfile=ftpcpr";break;
	case org.omg.FT.WARM_PASSIVE.value:one_arg[0]="-ORBProfile=ftpwpr";break;
	case org.omg.FT.ACTIVE.value:
	case org.omg.FT.ACTIVE_WITH_VOTING.value:one_arg[0]="-ORBProfile=ftpar";break;
	case org.omg.FT.STATELESS.value:one_arg[0]="-ORBProfile=ftpsr";break;
	}

	l_g_r_c=set_logg_rec_ctrl(org.omg.CORBA.ORB.init((String[])null,prop));
	prop.put("client.id",client_id);
	o=org.omg.CORBA.ORB.init(one_arg,prop);
	((org.openorb.CORBA.ORB)o).setFeature("request_duration",new Integer(10000));
	((org.openorb.CORBA.ORB)o).setFeature("logging_recovery_ctrl",l_g_r_c);
	if(trace_file!=null)
	    ((org.openorb.CORBA.ORB)o).setFeature("trace_file",trace_file);
	if(trace_file_gsu!=null)
	    ((org.openorb.CORBA.ORB)o).setFeature("trace_file_gsu",trace_file_gsu);
	if(type==ACTIVE.value||type==ACTIVE_WITH_VOTING.value)
	    ((org.openorb.CORBA.ORB)o).setFeature("gateway",null);
	return o;
    }

    private static org.omg.FT.LoggingRecoveryController set_logg_rec_ctrl(org.omg.CORBA.ORB orb){
	org.omg.CosNaming.NamingContext rootC=null,ftDomC=null,hostC=null;
	org.omg.CosNaming.NameComponent loggrcNC=new org.omg.CosNaming.NameComponent("loggrecc","text"),loggrcNCs[]={loggrcNC},fn=new org.omg.CosNaming.NameComponent(),fn_nc[],hostNCs[]=new org.omg.CosNaming.NameComponent[1];
	org.omg.FT.LoggingRecoveryController log_rec_ctrl=null;

	try{
	    fn.id=ftDom;
	    fn.kind="directory";
	    fn_nc=new org.omg.CosNaming.NameComponent[1];
	    fn_nc[0]=fn;
	    hostNCs[0]=new org.omg.CosNaming.NameComponent(location,"directory");
	    rootC=org.omg.CosNaming.NamingContextHelper.narrow(orb.resolve_initial_references("NameService"));
	    if(rootC==null) return null;
	    ftDomC=org.omg.FT.Utils.resolve_n(rootC,fn_nc);
	    if(ftDomC!=null){
		hostC=org.omg.FT.Utils.resolve_n(ftDomC,hostNCs);
		if(hostC!=null)
		    log_rec_ctrl=LoggingRecoveryControllerHelper.narrow(hostC.resolve(loggrcNCs));
		else log_rec_ctrl=null;
	    }
	}catch(Exception ex){
	    log_rec_ctrl=null;
	}
	return log_rec_ctrl;
    }

    private static org.omg.PortableServer.POA get_rootpoa(org.omg.CORBA.ORB o){
	org.omg.CORBA.Object poa_o=null;
	org.omg.PortableServer.POA poa=null;

	try{
	    poa_o=o.resolve_initial_references("RootPOA");
	    poa=org.omg.PortableServer.POAHelper.narrow(poa_o);
	}catch(Exception e){return null;}
	return poa;
    }


    private static org.omg.PortableServer.POA get_obj_poa(org.omg.CORBA.ORB o,String client_id){

	org.omg.CORBA.Object poa_o=null;
	org.omg.PortableServer.POA poa=null;
	org.omg.CORBA.Any a;

	poa=get_rootpoa(o);
	if(poa!=null){
	    org.omg.CORBA.Policy[] policies;
	    policies=new org.omg.CORBA.Policy[2];
	    policies[0]=poa.create_id_assignment_policy(org.omg.PortableServer.IdAssignmentPolicyValue.USER_ID);
	    a=o.create_any();
	    RequestDurationPolicyHelper.insert(a,new org.omg.FT.RequestDurationPolicyImpl(10000)._this(o));
	    try{
		policies[1]=o.create_policy(REQUEST_DURATION_POLICY.value,a);
	    }catch(Exception e){}
	    try{
		poa=poa.create_POA("factoryAdapter"+client_id,poa.the_POAManager(),policies);
	    }catch(Exception e){poa=null;}
	}
	((org.openorb.CORBA.ORB)o).setFeature("thePOA",poa);
	return poa;
    }

    private static org.omg.PortableServer.POA get_gw_poa(org.omg.CORBA.ORB o,String client_id){

	org.omg.CORBA.Object poa_o=null;
	org.omg.PortableServer.POA poa=null;

	poa=get_rootpoa(o);
	if(poa!=null){
	    org.omg.CORBA.Policy[] policies;
	    policies=new org.omg.CORBA.Policy[1];
	    policies[0]=poa.create_id_assignment_policy(org.omg.PortableServer.IdAssignmentPolicyValue.USER_ID);
	    try{
		poa=poa.create_POA("gatewayAdapter"+client_id,poa.the_POAManager(),policies);
	    }catch(Exception e){poa=null;}
	}
	return poa;
    }

     private static void create_gateway(String[] args){

	GatewayForActiveRepl_impl inst;
	org.omg.CORBA.Object toRet=null;
	org.omg.CORBA.ORB gw_orb;
	org.omg.PortableServer.POA gw_poa;
	byte[] oid;
	int sz,i;
	long oid_l;

	String one_arg[]={"-ORBProfile=ftpg"};
	java.util.Properties prop=new java.util.Properties();
	if(args[4].charAt(0)=='0')
	    {
		System.out.println("%%REF IS%%"+"null");
		return;
	    }

	prop.put("org.omg.CORBA.ORBClass","org.openorb.CORBA.ORB");
	prop.put("org.omg.CORBA.ORBSingletonClass","org.openorb.CORBA.ORBSingleton");

	String class_name=Utils.get_class_name(args[3]);
	if(args[4].charAt(0)=='1'){
	    oid=new byte[8];
	    for(i=0;i<8;i++)
		oid[i]=Byte.parseByte(args[5+i]);
	}
	else{
	    sz=Integer.parseInt(args[5]);
	    oid=new byte[sz];
	    for(i=0;i<sz;i++)
		oid[i]=Byte.parseByte(args[6+i]);
	}
	oid_l=Utils.makeByteId(oid);
	gw_orb=org.omg.CORBA.ORB.init(one_arg,prop);
	((org.openorb.CORBA.ORB)gw_orb).setFeature("request_duration",new Integer(10000));
/** if there is a need for a trace file in the gateway, it has to be creaeted here and set as a feature in the gateway ORB
*/

	String client_id=Long.toString(oid_l);
	gw_poa=get_gw_poa(gw_orb,client_id);

	inst=new org.omg.FT.GatewayForActiveRepl_impl(gw_orb,oid);
	((org.openorb.CORBA.ORB)gw_orb).setFeature("ItsGateway",inst);
	try{
	    gw_poa.activate_object_with_id(oid,inst);
	    toRet=gw_poa.create_reference_with_id(oid,"IDL:omg.org/FT/GatewayForActiveRepl:1.0");
	}catch(Exception e){toRet=null;}
	if(gw_poa!=null&&gw_orb!=null)
	    new ExcThread(gw_poa,gw_orb).start();
	System.out.println("%%REF IS%%"+gw_orb.object_to_string(toRet));
    }
}
